function gadget:GetInfo()
	return {
		name    = "Star-crap",
		desc    = "Implements neutral cappable crap to interact with.",
		author  = "Sprung",
		date    = "1/10/12",
		license = "PD",
		layer   = 10,
		enabled = true,
	}
end
if (not tobool(Spring.GetModOptions().xmas)) then return end 

local mapConfig = include("LuaRules/Configs/sc_map_def.lua")

if (not mapConfig) then return else
	local spGH = Spring.GetGroundHeight
	for i = 1, #mapConfig.towers do
		mapConfig.towers[i].draw = true
		mapConfig.towers[i].invulnerable = mapConfig.towers[i][5]
		mapConfig.towers[i][5] = mapConfig.towers[i][3]
		mapConfig.towers[i][3] = mapConfig.towers[i][2]
		mapConfig.towers[i][2] = spGH(mapConfig.towers[i][1], mapConfig.towers[i][3])
	end
	for i = 1, #mapConfig.rocks do
		mapConfig.rocks[i].invulnerable = mapConfig.rocks[i][4]
		mapConfig.rocks[i][4] = mapConfig.rocks[i][3]
		mapConfig.rocks[i][3] = mapConfig.rocks[i][2]
		mapConfig.rocks[i][2] = spGH(mapConfig.rocks[i][1], mapConfig.rocks[i][3])
	end
end

if (gadgetHandler:IsSyncedCode()) then
	local spCU = Spring.CreateUnit
	local neutral_team = Spring.GetGaiaTeamID()
	local neutral_allyteam = select(6,Spring.GetTeamInfo(neutral_team))

	local nearestAlly = Spring.GetUnitNearestAlly
	local getCyl = Spring.GetUnitsInCylinder
	local getPos = Spring.GetUnitPosition
	local giev = Spring.TransferUnit
	local getTeam = Spring.GetUnitTeam
	local getAllyTeam = Spring.GetUnitAllyTeam
	local getAllyList = Spring.GetTeamList
	local stund = Spring.GetUnitIsStunned
	local getMovetype = Spring.GetUnitMoveTypeData
	local SendToUnsync = SendToUnsynced
	local neutralize = Spring.SetUnitNeutral

	local xelnagas = {}
	local rocks = {}

	function gadget:GamePreload()
		for i = 1, #mapConfig.towers do
			local uid = spCU(mapConfig.towers[i][5], mapConfig.towers[i][1], mapConfig.towers[i][2], mapConfig.towers[i][3], 0, neutral_team)
			neutralize(uid, true)
			Spring.SetUnitAlwaysVisible(uid, true) -- brief visiblity for a ghost site to appear
			xelnagas[uid] = i
		end
		for i = 1, #mapConfig.rocks do
			local uid = spCU(mapConfig.rocks[i][4], mapConfig.rocks[i][1], mapConfig.rocks[i][2], mapConfig.rocks[i][3], 0, neutral_team)
			neutralize(uid, true)
			Spring.SetUnitAlwaysVisible(uid, true)
			rocks[uid] = i
		end
	end

	function gadget:AllowWeaponTarget(unitID, targetID, attackerWeaponNum, attackerWeaponDefID, defPriority)
		if(targetID and xelnagas[targetID] and mapConfig.towers[xelnagas[targetID]].invulnerable) then
			return false, defPriority
		end
		if(targetID and rocks[targetID] and mapConfig.rocks[rocks[targetID]].invulnerable) then
			return false
		end
		return true, defPriority
	end

	function gadget:AllowCommand(unitID, unitDefID, unitTeam, cmdID, cmdParams, cmdOptions, cmdTag)
		if ((cmdID == CMD.ATTACK or cmdID == CMD.MANUALFIRE) and #cmdParams == 1) then
			local targetID = cmdParams[1]
			if(targetID and xelnagas[targetID] and mapConfig.towers[xelnagas[targetID]].invulnerable) then
				return false
			end
			if(targetID and rocks[targetID] and mapConfig.rocks[rocks[targetID]].invulnerable) then
				return false
			end
		end
		return true
	end

	function gadget:UnitPreDamaged(targetID, unitDefID, unitTeam, damage)
		if(targetID and xelnagas[targetID] and mapConfig.towers[xelnagas[targetID]].invulnerable) then
			return 0 -- can't touch this!
		end
		if(targetID and rocks[targetID] and mapConfig.rocks[rocks[targetID]].invulnerable) then
			return 0
		end
		return damage
	end

	function gadget:UnitDestroyed(uid, udef, team)
		if(uid) then
			if(xelnagas[uid]) then
				_G.XelTowerPwned = xelnagas[uid]
				SendToUnsync("XelTowerPwned")
				_G.XelTowerPwned = nil
				xelnagas[uid] = nil
			elseif(rocks and rocks[uid]) then
				rocks[uid] = nil
			end
		end
	end

	function gadget:GameFrame(n)
		if(n == 30) then
			for id,_ in pairs(xelnagas) do
				Spring.SetUnitAlwaysVisible(id, false)
			end
			for id,_ in pairs(rocks) do
				Spring.SetUnitAlwaysVisible(id, false)
			end
		end
		if (n % 30 == 5) then
			for id, data_id in pairs(xelnagas) do
				local x,_,z = getPos(id)
				local nubs = getCyl(x, z, mapConfig.towers[data_id][4])
				local counts = {}
				local ally_of_id = getAllyTeam(id)
				counts[ally_of_id] = -1
				for i = 1, #nubs do
					local nub = nubs[i]
					if((nub == id) or (not stund(nub) and getMovetype(nub).name ~= "airplane" and getMovetype(nub).name ~= "gunship" and getMovetype(nub).name ~= "static")) then
						local allied = getAllyTeam(nub)
						counts[allied] = (counts[allied] or 0) + 1
					end
				end
				local winnar = nil
				if(#counts < 2) then
					for allyteam, units in pairs(counts) do
						if (units > 0) then
							if (not winnar) then winnar = allyteam else winnar = nil end
						end
					end
				end
				if(not winnar) then
					if (neutral_team ~= ally_of_id) then
						if (GG.shareunits) then -- bypass the "dont share to enemy" thingy from ZK
							GG.shareunits[id] = true
						end
						giev(id, neutral_team, false)
						neutralize(id, true)
						local func = Spring.UnitScript.GetScriptEnv(id)
						if (func) then
							func = func.script.Deactivate
							if (func) then
								Spring.UnitScript.CallAsUnit(id,func, {}) -- call Deactivate(), if unit has one
							end
						end
					end
				elseif(winnar ~= ally_of_id) then
					counts = {}
					for i = 1, #nubs do
						local nubTeam = getTeam(nubs[i])
						if(getAllyTeam(nubs[i]) == winnar) then
							counts[nubTeam] = (counts[nubTeam] or 0) + 1
						end
					end
					winnar = nil
					local macks = -1337
					for team, units in pairs(counts) do
						if (units > macks) then
							winnar = team
							macks = units
						end
					end
					if (GG.shareunits) then
						GG.shareunits[id] = true
					end
					giev(id, winnar, false)
					--if (GG.shareunits) then
					--	GG.shareunits[id] = true
					--end
					--giev(id, getTeam(nearestAlly(id, mapConfig.towers[data_id][4])), false)
					neutralize(id, true)
					local func = Spring.UnitScript.GetScriptEnv(id)
					if (func) then
						func = func.script.Activate
						if (func) then
							Spring.UnitScript.CallAsUnit(id,func, {})
						end
					end
				end
			end
		end
	end
else -- un/sync
	local glColor = gl.Color
	local glDrawGroundCircle = gl.DrawGroundCircle

	function gadget:Initialize()
		gadgetHandler:AddSyncAction("XelTowerPwned", function() mapConfig.towers[SYNCED.XelTowerPwned].draw = false end)
	end

	function gadget:DrawWorldPreUnit()
		glColor(1.0, 1.0, 1.0, 0.4)
		for i = 1, #mapConfig.towers do
			if(mapConfig.towers[i].draw) then glDrawGroundCircle(mapConfig.towers[i][1], mapConfig.towers[i][2], mapConfig.towers[i][3], mapConfig.towers[i][4], 32) end
		end
		glColor(1,1,1,1)
	end
end